UNIT mTBall;

interface

uses        mSuM,mTSpielfeld, math;
// Uses-Klausel ggf. anpassen

type
   TKugel = CLASS (TObject)

     // Attribute
     private
        hatStift : Stift;
        kenntSpielfeld : TSpielfeld;

     //Objektbeziehungen:
        // hatStift : Stift;
        // kenntTSpielfeld : TSpielfeld;

     // Methoden
     private
        procedure loesche;
        procedure setzeRichtung(pWinkel:Zahl);
        procedure zeichne;
     public
        constructor init(px,py,pRichtung:Zahl);
        procedure bewege;
        procedure merkeSpielfeld(pSpielfeld : TSpielfeld);
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- loesche (private) -------------------------------------------
procedure TKugel.loesche;
begin
  hatStift.radiere;   //test
  self.Zeichne;
  hatStift.normal
end;

//-------- setzeRichtung (private) -------------------------------------
procedure TKugel.setzeRichtung(pWinkel:Zahl);
begin
  hatStift.dreheBis(pWinkel)
end;

//-------- zeichne (private) -------------------------------------------
procedure TKugel.zeichne;
begin
  hatStift.zeichneKreis(10);
end;

//-------- init (public) -----------------------------------------------
constructor TKugel.init(px,py,pRichtung:Zahl);
begin
  hatStift := Stift.init;       // Stift erzeugen
  hatStift.bewegeBis(px,py);
  hatStift.dreheBis(pRichtung);
  self.zeichne
end;

//-------- bewege (public) ---------------------------------------------
procedure TKugel.bewege;
   var vx,vy :Zahl;
begin
  self.loesche;
  hatStift.bewegeUm(0.1);       // an die Geschwindigkeit des Rechners anpassen!
  if hatStift.hPosition > kenntSpielfeld.liesRechts -12 then
     hatStift.dreheBis (180-hatStift.winkel);
  if hatStift.hPosition < kenntSpielfeld.liesLinks + 12 then
     hatStift.dreheBis (180-hatStift.winkel);
  if hatStift.vPosition < kenntSpielfeld.liesOben + 12 then
     hatStift.dreheBis (-hatStift.winkel);
  if hatStift.vPosition > kenntSpielfeld.liesUnten - 12 then
     hatStift.dreheBis (-hatStift.winkel);
  self.Zeichne;
end;

//-------- merkeSpielfeld (public) -------------------------------------
procedure TKugel.merkeSpielfeld(pSpielfeld : TSpielfeld);
begin
   kenntSpielfeld := pSpielfeld  ///test
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKugel.gibFrei;
begin
  hatStift.gibFrei;             // Stift wieder freigeben
end;

end.
