UNIT mTKugel;

interface

uses             mSuM,mTSpielfeld, math,classes;
// Uses-Klausel ggf. anpassen

type
   TKugel = CLASS

     // Attribute
     private
        kenntSpielfeld : TSpielfeld;
        zSichtbar : Wahrheitswert;
     public
        hatStift : BuntStift;

     // Methoden
     private
        procedure loesche;
        procedure setzeRichtung(pWinkel:Zahl);
     public
        constructor init(px,py,pRichtung:Zahl);
        procedure bewege;
        procedure merkeSpielfeld(pSpielfeld:TSpielfeld);
        procedure verstecke;
        procedure zeichne;
        procedure zeige;
        function sichtbar : Wahrheitswert;
        function Treffer(px,py:ganzeZahl) : Wahrheitswert;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- loesche (private) -------------------------------------------
procedure TKugel.loesche;
begin
  hatStift.radiere;   //test
  hatStift.zeichneKreis(10);
  hatStift.normal
end;

//-------- setzeRichtung (private) -------------------------------------
procedure TKugel.setzeRichtung(pWinkel:Zahl);
begin
  hatStift.dreheBis(pWinkel)
end;

//-------- init (public) -----------------------------------------------
constructor TKugel.init(px,py,pRichtung:Zahl);
begin
  hatStift := BuntStift.init;       // Stift erzeugen
  hatStift.setzeFarbe(rot);
  hatStift.setzeFuellMuster(gefuellt);
  hatStift.bewegeBis(px,py);
  hatStift.dreheBis(pRichtung);
  zSichtbar := wahr;
  self.zeichne
end;

//-------- bewege (public) ---------------------------------------------
procedure TKugel.bewege;
   var vx,vy :Zahl;
begin
  if zSichtbar then
    begin
      self.loesche;
      hatStift.bewegeUm(1);       // an die Geschwindigkeit des Rechners anpassen!
      if hatStift.hPosition > kenntSpielfeld.liesRechts -12 then
         hatStift.dreheBis (180-hatStift.winkel);
      if hatStift.hPosition < kenntSpielfeld.liesLinks + 12 then
         hatStift.dreheBis (180-hatStift.winkel);
      if hatStift.vPosition < kenntSpielfeld.liesOben + 12 then
         hatStift.dreheBis (-hatStift.winkel);
      if hatStift.vPosition > kenntSpielfeld.liesUnten - 12 then
         hatStift.dreheBis (-hatStift.winkel);
      self.Zeichne;
    end
end;

//-------- merkeSpielfeld (public) -------------------------------------
procedure TKugel.merkeSpielfeld(pSpielfeld:TSpielfeld);
begin
   kenntSpielfeld := pSpielfeld  ///test
end;

//-------- verstecke (public) ------------------------------------------
procedure TKugel.verstecke;
begin
  loesche;
  zSichtbar := Falsch
end;

//-------- zeichne (public) --------------------------------------------
procedure TKugel.zeichne;
begin
   if ZSichtbar then
      begin
         hatStift.normal;
         hatStift.zeichneKreis(10)
      end   
   else
      begin
         hatStift.radiere;
         hatStift.zeichneKreis(10)
      end
end;

//-------- zeige (public) ----------------------------------------------
procedure TKugel.zeige;
begin
  zSichtbar := true
end;

//-------- sichtbar (public) -------------------------------------------
function TKugel.sichtbar : Wahrheitswert;
begin
  result := zSichtbar
end;

//-------- Treffer (public) --------------------------------------------
function TKugel.Treffer(px,py:ganzeZahl) : Wahrheitswert;
begin
if zSichtbar then
   begin
      if ( sqrt(sqr(hatStift.hPosition-px)+sqr(hatStift.vPosition-py))
                   <= 10 ) then
          begin
             verstecke;
             result := true
          end
      else
         result := false
   end
else
   result := false
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKugel.gibFrei;
begin
  hatStift.setzefarbe(schwarz);
  self.zeichne;
  hatStift.gibFrei;             // Stift wieder freigeben
end;

end.
