unit UHangman;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  THangman = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Label4: TLabel;
    Image1: TImage;
    Panel1: TPanel;
    Label5: TLabel;
    function DUpcase(Buchstabe : char) : char;
    function leerweg(wort : string): string;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    ratewort, ausgabewort :  string;
    treffer, verloren, gewonnen : boolean;
    trefferzahl, versuch, fehlversuche : integer;
  public
    { Public-Deklarationen }
  end;

  const Ratewoerter = ',RATESPIEL,BUNDESLIGA,PFERDERENNEN,ALPHABET,BIERGARTEN,'+
  'MBELWAGEN,FLUGREISE,SOMMERFERIEN,MISTGABEL,SAMURAI,RENNWAGEN,'+
  'FLUGZEUGTRGER,LAUBFROSCH,WEIHNACHTSBAUM,OSTERHASE,REGENSCHAUER,'+
  'SCHLITTENFAHRT,SCHNEEMANN,KOCHLFFEL,LOKOMOTIVE';

var
  Hangman: THangman;

implementation

{$R *.DFM}

function THangman.DUpcase(Buchstabe : char) : char;
begin
  case Buchstabe of
    'a'..'z' : result := upcase(Buchstabe);
    ''      : result := '';
    ''      : result := '';
    ''      : result := '';
   else result := Buchstabe;
   end;
end;
function THangman.leerweg(wort : string): string;
var i, laenge : integer;
    puffer : string;
begin
  puffer := '';
  laenge := length(wort);
  for i := 1 to laenge div 2 do
  puffer := puffer + wort[2*i-1];
  result := puffer;
end;

procedure THangman.FormCreate(Sender: TObject);
var i,m,n,o : integer;
begin
  randomize;
  image1.Canvas.Create;
  n := random(20)+1;
  trefferzahl := 0; versuch := 0; fehlversuche := 0;
  treffer := false; verloren := false; gewonnen := false;
  ausgabewort := ''; ratewort := '';
  m := 0;o := 1;
  repeat
    If Ratewoerter[o] = ',' then m := m+1; o := o+1;
  until m = n;
  repeat
    Ratewort := ratewort + ratewoerter[o]; o := o+1;
  until ratewoerter[o] = ',';
  for i := 1 to length(ratewort) do ausgabewort := ausgabewort+'_ ';
  panel1.Caption := ausgabewort;
end;

procedure THangman.FormKeyPress(Sender: TObject; var Key: Char);
var i : integer;
begin
  if (not verloren) and (not gewonnen) then
  begin
  versuch := versuch + 1;
  label4.Caption := intToStr(versuch);
  edit1.text := '   '+DUpcase(key);
  for i := 1 to length(ratewort) do
  begin
    if ratewort[i] = DUpcase(key) then
    begin
      treffer := true;
      ausgabewort[2*i-1] := DUpcase(key);
      panel1.Caption := ausgabewort;
    end;
  end;
  if not treffer then fehlversuche := fehlversuche + 1 else treffer := false;
  with image1.Canvas do
  case fehlversuche of
    1 : begin pen.width := 3; moveTo(20,250); LineTo(150,250); end;
    2 : begin moveTo(85,250); lineTo(85,30); end;
    3 : begin lineTo(130,30); moveTo(125,30); lineTo(125,50); end;
    4 : begin ellipse(110,50,140,80); moveTo(125,80); lineTo(125,90); end;
    5 : begin ellipse(105,90,145,200); end;
    6 : begin moveTo(114,99); LineTo(90,60); end;
    7 : begin moveTo(136,99); LineTo(160,60); end;
    8 : begin moveTo(114,194); lineTo(109,235); end;
    9 : begin moveTo(136,194); lineTo(141,235);  end;
   10: begin moveTo(109,235); lineTo(100,233); end;
   11: begin moveTo(141,235); lineTo(150,233); end;
  end;
  if fehlversuche = 11 then
  begin
    label5.Caption := 'verloren!!';
    verloren := true;
  end;
  if leerweg(ausgabewort) = ratewort then
  begin
    label5.Caption := 'gewonnen!!';
    gewonnen := true;
  end;

  end;
end;

end.
