unit mVerbindung;
interface
uses ScktComp, Forms, Windows, Messages, SysUtils, Classes, Graphics, Controls,
      Dialogs, StDCtrls, mProtokollfenster, mListe, mTextwerkzeug, mSum;
const
  NTrenner=#$D#$A;
type
  ZeichenketteObjekt = class
                   private
                   zInhalt:Zeichenkette;
                   public
                   constructor init(pInhalt:Zeichenkette);
                   procedure setzeInhalt(pInhalt:Zeichenkette);
                   function Inhalt:Zeichenkette;
                   destructor gibFrei;
                 end;

  Verbindung = class
                 private
                 hatSocket:TClientSocket;
                 zMitProtokoll, zAngemeldet, zGelesen:Wahrheitswert;
                 hatClientKontrollfenster:TKontrollfenster;
                 zServerPort, zClientport:GanzeZahl;
                 zServerAdresse, zClientAdresse:Zeichenkette;
                 zNachricht:Zeichenkette;
                 zFehler:Wahrheitswert;
                 hatTextwerkzeug:Textwerkzeug;
                 protected
                 hatListe:Liste;
                 procedure ClientSocketRead(Sender: TObject;Socket: TCustomWinSocket); virtual;
                 procedure ClientSocketError(Sender: TObject;Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: GanzeZahl);
                 procedure ClientSocketConnect(Sender: TObject;Socket: TCustomWinSocket);
                 procedure ClientSocketDisconnect(Sender: TObject;Socket: TCustomWinSocket);
                 public
                 constructor init(pIPAdresse:Zeichenkette; pPortNr:GanzeZahl; pMitProtokollieren:Wahrheitswert);
                 procedure sende(pNachricht:Zeichenkette);virtual;
                 function empfangeneNachricht:Zeichenkette;
                 function partnerAdresse:Zeichenkette;
                 function eigeneAdresse:Zeichenkette;
                 function partnerPort:GanzeZahl;
                 function eigenerPort:GanzeZahl;
                 function vorhanden:Wahrheitswert;
                 function mitProtokoll:Wahrheitswert;
                 destructor gibFrei; virtual;
                end;
implementation

    constructor ZeichenketteObjekt.init(pInhalt:Zeichenkette);
    begin

      zInhalt:=pInhalt;
    end;

    procedure ZeichenketteObjekt.setzeInhalt(pInhalt:Zeichenkette);
    begin
      zInhalt:=pInhalt;
    end;

    function ZeichenketteObjekt.Inhalt:Zeichenkette;
    begin
      result:=zInhalt;
    end;

    destructor ZeichenketteObjekt.gibFrei;
    begin
    end;

   constructor Verbindung.init(pIPAdresse:Zeichenkette; pPortNr:GanzeZahl; pMitProtokollieren:Wahrheitswert);
   begin
    hatListe:=Liste.init;
    hatTextwerkzeug:=Textwerkzeug.init;
    hatSocket:=TClientSocket.Create(nil);
    hatSocket.Host:=pIPAdresse;
    hatSocket.Port:=pPortNr;
    zMitProtokoll:=pMitProtokollieren;
    zFehler:=false;
    zGelesen:=false;
    hatSocket.onError:=clientSocketError;
    hatSocket.onRead:=ClientSocketRead;
    hatSocket.onConnect:=ClientSocketConnect;
    hatSocket.open;
    if zMitProtokoll then begin
       hatClientKontrollfenster:=TKontrollfenster.create(Application);
       hatClientKontrollfenster.show;
       hatClientKontrollfenster.Top:=300;
    end;
    while not hatSocket.socket.connected and not zFehler do
      application.processMessages;
  end;

  procedure Verbindung.sende(pNachricht:Zeichenkette);
  begin
    hatSocket.socket.sendText(pNachricht+NTrenner);
    zNachricht:='';
    if zMitProtokoll then
     hatClientKontrollfenster.memo1.lines.add('Verbindung sendet '+pNachricht);
  end;

  function Verbindung.empfangeneNachricht:Zeichenkette;
  var
    lNachricht:Zeichenkette;
  begin
    while zAngemeldet and hatListe.istLeer do
      Application.ProcessMessages;
    if zAngemeldet then begin
      hatListe.zumAnfang;
      lNachricht:=ZeichenketteObjekt(hatListe.aktuelles).Inhalt;
      result:=lNachricht;
      hatListe.entferneAktuelles;
    end;
  end;

  function Verbindung.mitProtokoll:Wahrheitswert;
  begin
    result:=zMitProtokoll;
  end;

  function Verbindung.partnerAdresse:Zeichenkette;
  begin
    result:=zServerAdresse;
  end;

  function Verbindung.partnerPort:GanzeZahl;
  begin
   result:=zServerPort;
  end;

  function Verbindung.eigeneAdresse:Zeichenkette;
  begin
    result:=zClientAdresse;
  end;

  function Verbindung.eigenerPort:GanzeZahl;
  begin
    result:=zClientport
  end;

  function Verbindung.vorhanden:Wahrheitswert;
  begin
    result:=self.hatSocket.socket.connected;
  end;

  destructor Verbindung.gibFrei;
  begin
    hatSocket.close;
    zAngemeldet:=false;
    hatClientKontrollfenster.free;
  end;

  procedure Verbindung.ClientSocketRead(Sender: TObject;Socket: TCustomWinSocket);
  var
    lNachricht, lEineNachricht:Zeichenkette;
  begin
    lNachricht:=Socket.receiveText;
    hatTextwerkzeug.setzeTrennung(NTrenner);
    repeat
      lEineNachricht:=hatTextwerkzeug.wortAn(lNachricht,1);
      if hatTextwerkzeug.laenge(lEineNachricht)=hatTextwerkzeug.laenge(lNachricht) then
        lNachricht:=''
      else
        lNachricht:=hatTextwerkzeug.textOhne(lNachricht,1,hatTextwerkzeug.laenge(lEineNachricht)+hatTextwerkzeug.laenge(NTrenner));
      if lEineNachricht<>'' then
        hatListe.haengeAn(ZeichenketteObjekt.init(lEineNachricht));
      if zMitProtokoll then
        hatClientKontrollfenster.memo1.lines.add('Verbindung liest '+lEineNachricht);
    until lNachricht='';
  end;


  procedure Verbindung.ClientSocketConnect(Sender: TObject;Socket: TCustomWinSocket);
  begin
    zServerAdresse:=hatSocket.socket.remoteAddress;
    zServerPort:=hatSocket.socket.remotePort;
    zClientAdresse:=hatSocket.socket.localAddress;
    zClientPort:=hatSocket.socket.localPort;
    zAngemeldet:=true;
    if zMitProtokoll then
       hatClientKontrollfenster.memo1.lines.add(zClientAdresse +' ist an Port '+intToStr(zClientPort)+' mit Server '+zServerAdresse+' an Port '+intToStr(zServerPort)+' verbunden.');
  end;

  procedure Verbindung.ClientSocketDisconnect(Sender: TObject;Socket: TCustomWinSocket);
  begin
    zClientAdresse:=hatSocket.socket.localAddress;
    zAngemeldet:=false;
    if zMitProtokoll then
       hatClientKontrollfenster.memo1.lines.add(zClientAdresse +' hat sich abgemeldet');
  end;

  procedure Verbindung.ClientSocketError(Sender: TObject;Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: GanzeZahl);
  var
    lFehler:Zeichenkette;
  begin
    case ErrorEvent of
    eeGeneral:lFehler:='Unbekannter Fehler';
    eeSend:lFehler:='Der Client konnte nicht senden';
    eeReceive:lFehler:='Der Client konnte keine Nachricht empfangen';
    eeConnect:lFehler:='Der Client konnte keine Verbindung aufbauen';
    eeDisconnect:lFehler:='Die Verbindung konnte nicht geschlossen werden.';
    eeAccept:lFehler:='Der Client konnte keine Verbindung aufbauen';
   else
      lFehler:='Verbindungsfehler';
    end;
    if zMitProtokoll then
       hatClientKontrollfenster.memo1.lines.add(lFehler);
    zFehler:=true;
  end;

end.
