unit hangman_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

const
  nmax = 7;
  serienName = 'hang';
  woerter: array [1..nmax] of string = ('ADRENALIN', 'COMPUTER', 'SEGELYACHT',
  'HEXENKESSEL', 'WANDERVOGEL', 'WASCHMASCHINE', 'ALLESKOENNER');

type
  TForm1 = class(TForm)
    Image1: TImage;
    neuButton: TButton;
    endeButton: TButton;
    suchwortLabel: TLabel;
    GroupBox1: TGroupBox;
    goButton: TButton;
    zeigeButton: TButton;
    goMemo: TMemo;
    hangManButton: TButton;
    Label1: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure endeButtonClick(Sender: TObject);
    procedure neuButtonClick(Sender: TObject);
    procedure goButtonClick(Sender: TObject);
    procedure hangManButtonClick(Sender: TObject);
    procedure zeigeButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
    bildNr: integer;
    bildname, suchwort: string;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormActivate(Sender: TObject);
begin
  randomize;
  BildNr := 1;
  groupBox1.Enabled := false;
  zeigeButton.Enabled := false
end;

function zweistellig (n: integer): string;
var s: string;
begin
  s := intToStr (n);
  if length (s) < 2 then s := '0' + s;
  result := s
end;

procedure TForm1.hangManButtonClick(Sender: TObject);
begin
  bildName := serienName + zweistellig (bildNr) + '.bmp';
  if fileExists (bildName)
    then
      begin
        image1.picture.LoadFromFile (bildName);
        if bildNr < 11 then inc (bildNr);
        hangManButton.caption := '&HangMan ' + intToStr (bildNr)
      end
    else ShowMessage ('Bilddatei "' + bildName + '" nicht gefunden');
end;

procedure TForm1.endeButtonClick(Sender: TObject);
begin
  application.ProcessMessages;
  close
end;

procedure TForm1.neuButtonClick(Sender: TObject);
var i: integer;
begin
  groupBox1.Enabled := true;
  zeigeButton.Enabled := true;
  label1.caption := '';
  goMemo.clear;
  suchwort := woerter [1 + random (nmax)];
  suchwortLabel.caption := '';
  for i := 1 to length (suchwort) do
    begin
      suchwortLabel.caption := suchwortLabel.caption + '-';
      application.ProcessMessages;
      sleep (100);
    end;
  with image1, canvas do rectangle (0, 0, width, height);
  bildNr := 1;
  hangManButton.caption := '&HangMan ' + intToStr (bildNr);
  goMemo.setFocus
end;

procedure TForm1.goButtonClick(Sender: TObject);
var c: char; p: byte; s: string;
begin
  if goMemo.text <> ''
    then
      begin
        c := upcase (goMemo.text [1]);
        p := pos (c, suchwort);
        if p > 0
          then
            while p > 0 do
              begin
                s := suchwortLabel.caption;
                s [p] := c;
                suchwort [p] := '_';
                suchwortLabel.caption := s;
                application.ProcessMessages;
                p := pos (c, suchwort);
              end
          else hangManButtonClick (sender);
        goMemo.clear
      end
    else showMessage ('Erst Buchstaben eingeben!');
  goMemo.setFocus
end;


procedure TForm1.zeigeButtonClick(Sender: TObject);
begin
  label1.caption := suchwort;
end;

end.
