{*******************************************************************************
 *                               Binaerbaum Version 1.1                        *
 *                (c) 2003 Klaus Dingemann und Ulrich Borghoff                 *
 *                           eMail: sum-delphi@web.de                          *
 * *****************************************************************************
 * Diese Binaerbaum Version luft auf allen Delphi Versionen ab 4.0            *                                                                             *
 * Bitte ndern Sie diese Datei nicht ab, sondern teilen den Entwicklern Ihre  *
 * Verbesserungsvorschlge oder Fehler (und ggf. deren Berichtigung) mit.      *
 *                                                                             *
 * Fr den Unterricht sollten Sie nur die mBinaerbaum.dcu Datei verwenden.     *
 * Diese muss sich im Ordner ..delphi/lib befinden. Die Angabe                 *
 * "uses mBinaerbaum" ist dann schon ausreichend.                              *
 *                                                                             *
 * Danke fr Ihre Mitarbeit.                                                   *
 *******************************************************************************}
 unit mBinaerbaum;

interface
type
   Binaerbaum = class
                kenntInhalt:TObject;
                kenntLinkenNachfolger, kenntRechtenNachfolger:Binaerbaum;
                constructor init;overload;
                constructor init(pInhalt:TObject);overload;
                constructor init(pInhalt:TObject;pLinkerBaum, pRechterBaum:Binaerbaum);overload;
                function neuerLeererBaum:Binaerbaum;
                procedure ueberschreibeWurzel(pInhalt:TObject);
                procedure haengeRechtsAn(pBaum:Binaerbaum);
                procedure haengeLinksAn(pBaum:Binaerbaum);
                procedure entferneAlle;
                function wurzelInhalt:TObject;
                function linkerTeilbaum:Binaerbaum;
                function rechterTeilbaum:Binaerbaum;
                function istLeer:boolean;
                function teilbaeumeLeer:boolean;
                destructor gibFrei;virtual;
               end;

implementation

  constructor Binaerbaum.init;
  begin
    kenntInhalt:=nil;
    kenntLinkenNachfolger:=nil;
    kenntRechtenNachfolger:=nil;

  end;

  constructor Binaerbaum.init(pInhalt:TObject);
  begin
    kenntInhalt:=pInhalt;
    kenntLinkenNachfolger:=self.neuerLeererBaum;
    kenntRechtenNachfolger:=self.neuerLeererBaum;
  end;


  constructor Binaerbaum.init(pInhalt:TObject;pLinkerBaum, pRechterBaum:Binaerbaum);
  begin
    kenntInhalt:=pInhalt;
    kenntLinkenNachfolger:=pLinkerBaum;
    kenntRechtenNachfolger:=pRechterBaum;
  end;

  procedure Binaerbaum.ueberschreibeWurzel(pInhalt:TObject);
  begin
    if (kenntInhalt=nil) and (pInhalt<>nil) then begin
      kenntLinkenNachfolger:=self.neuerLeererBaum;
      kenntRechtenNachfolger:=self.neuerLeererBaum;
    end;
    kenntInhalt:=pInhalt;
  end;

  function Binaerbaum.neuerLeererBaum:Binaerbaum;
  begin
    result:=Binaerbaum.init;
  end;

  procedure Binaerbaum.haengeRechtsAn(pBaum:Binaerbaum);
  begin
    if not self.istLeer then
      kenntRechtenNachfolger:=pBaum;
  end;

  procedure Binaerbaum.haengeLinksAn(pBaum:Binaerbaum);
  begin
    if not self.istLeer then
       kenntLinkenNachfolger:=pBaum;
  end;

  procedure Binaerbaum.entferneAlle;
  begin
    if not self.linkerTeilbaum.istLeer then
      self.linkerTeilbaum.entferneAlle
    else
      self.linkerTeilbaum.gibFrei;
    if not self.rechterTeilbaum.istLeer then
      self.rechterTeilbaum.entferneAlle
    else
      self.rechterTeilbaum.gibFrei;
    if not self.istLeer then
      kenntInhalt.destroy;
    kenntInhalt:=nil;
    kenntRechtenNachfolger:=nil;
    kenntLinkenNachfolger:=nil;
  end;

  function Binaerbaum.WurzelInhalt:TObject;
  begin
    result:=kenntInhalt;
   end;

  function Binaerbaum.linkerTeilbaum:Binaerbaum;
  begin
    result:=kenntLinkenNachfolger;
  end;

  function Binaerbaum.rechterTeilbaum:Binaerbaum;
  begin
    result:=kenntRechtenNachfolger;
  end;

  function Binaerbaum.istLeer:boolean;
  begin
    result:=kenntInhalt=nil;
  end;

  function Binaerbaum.teilbaeumeLeer:boolean;
  begin
    result:=kenntLinkenNachfolger.istLeer and kenntRechtenNachfolger.istLeer;
  end;

  destructor Binaerbaum.gibFrei;
  begin
  end;


end.
