{*******************************************************************************
 *                              EBFormular Version 1.0                         *
 *                (c) 2002 Ulrich Borghoff    Gymnasium Wilnsdorf              *
 *                           eMail: sum-delphi@web.de                          *
 * *****************************************************************************
 * Diese Komponenten Version drfte unter Delphi ab Version ab 4 laufen        *
 *******************************************************************************
 * Bitte ndern Sie diese Datei nicht ab, sondern teilen den Entwicklern Ihre  *
 * Verbesserungsvorschlge oder Fehler (und ggf. deren Berichtigung) mit.      *
 *                                                                             *
 * Danke fr Ihre Mitarbeit.                                                   *
 *******************************************************************************}


unit mEBFormular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mSum;

type
  TEBFormular = class(TForm)

  {Nachrichten}
    constructor Create(AOwner: TComponent); override;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDblClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);

  private
    zHPosition,zVPosition:Zahl;
    hatEreignisverteiler:Ereignisverteiler;
    zInitialisiert:boolean;
    procedure idle(Sender: TObject; var Done: Boolean);
    procedure initialisierung;

  public
    procedure init; virtual;
    procedure bearbeiteTaste(pZeichen:Zeichen); virtual;
    procedure bearbeiteMausDruck(pHPosition,pVPosition:Zahl); virtual;
    procedure bearbeiteMausBewegt(pHPosition,pVPosition:Zahl); virtual;
    procedure bearbeiteMausLos(pHPosition,pVPosition:Zahl); virtual;
    procedure bearbeiteDoppelklick(pHPosition,pVPosition:Zahl); virtual;
    procedure bearbeiteLeerlauf; virtual;
    procedure beenden;
    procedure neuerEreignisbearbeiter(pNeu:EreignisBearbeiter);
    procedure gibFrei; virtual;

  end;

implementation

{$R *.DFM}

constructor TEBFormular.Create(AOwner: TComponent);
begin
  inherited create(AOwner);
  zInitialisiert:=false;
end;

procedure TEBFormular.initialisierung;
begin
  hatEreignisverteiler:=Ereignisverteiler.init;
  if (screen.activeForm is TEBFormular) then
    application.onidle:=TEBFormular(screen.activeForm).idle;
  zInitialisiert:=true;
  self.init;
end;  

procedure TEBFormular.init;
begin
end;

procedure TEBFormular.bearbeiteTaste(pZeichen:Zeichen);
begin
  hatEreignisverteiler.bearbeiteTaste(pZeichen);
end;

procedure TEBFormular.bearbeiteMausDruck(pHPosition,pVPosition:Zahl);
begin
  hatEreignisverteiler.bearbeiteMausDruck(pHPosition,pVPosition);
end;

procedure TEBFormular.bearbeiteMausLos(pHPosition,pVPosition:Zahl);
begin
  hatEreignisverteiler.bearbeiteMausLos(pHPosition,pVPosition);
end;

procedure TEBFormular.bearbeiteMausBewegt(pHPosition,pVPosition:Zahl);
begin
  hatEreignisverteiler.bearbeiteMausBewegt(pHPosition,pVPosition);
end;

procedure TEBFormular.bearbeiteDoppelKlick(pHPosition,pVPosition:Zahl);
begin
  hatEreignisverteiler.bearbeiteDoppelKlick(pHPosition,pVPosition);
end;

procedure TEBFormular.bearbeiteLeerlauf;
begin
  hatEreignisverteiler.bearbeiteLeerlauf;
end;

procedure TEBFormular.beenden;
begin
  self.gibFrei;
end;

procedure TEBFormular.neuerEreignisbearbeiter(pNeu:EreignisBearbeiter);
begin
  hatEreignisverteiler.einfuegen(pNeu);
end;

procedure TEBFormular.gibFrei;
begin
  if hatEreignisverteiler <> nil then hatEreignisverteiler.gibFrei;
  self.close;
end;

{private Ereignismethoden}

procedure TEBFormular.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if not zInitialisiert then self.initialisierung;
  self.bearbeiteTaste(Key);
end;

procedure TEBFormular.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if not zInitialisiert then self.initialisierung;
  if button=mbLeft then self.bearbeiteMausDruck(x,y);
end;

procedure TEBFormular.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if not zInitialisiert then self.initialisierung;
  zHPosition:=x;
  zVPosition:=y;
  self.bearbeiteMausBewegt(x,y);
end;

procedure TEBFormular.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if not zInitialisiert then self.initialisierung;
  if button=mbLeft then self.bearbeiteMausLos(x,y);
end;

procedure TEBFormular.FormDblClick(Sender: TObject);
begin
  if not zInitialisiert then self.initialisierung;
  self.bearbeiteDoppelklick(zHPosition,zVPosition);
end;

procedure TEBFormular.idle(Sender: TObject; var Done: Boolean);
begin
  if not zInitialisiert then self.initialisierung;
  done:=false;
  if self <> nil then self.bearbeiteLeerlauf;
end;

procedure TEBFormular.FormPaint(Sender: TObject);
begin
  if not zInitialisiert then self.initialisierung;
end;

end.
