{*******************************************************************************
 *                               Suchbaum Version 1.1                          *
 *                (c) 2003 Klaus Dingemann und Ulrich Borghoff                 *
 *                           eMail: sum-delphi@web.de                          *
 * *****************************************************************************
 * Diese Suchbaum Version luft auf allen Delphi Versionen ab 4.0              *                                                                             *
 * Bitte ndern Sie diese Datei nicht ab, sondern teilen den Entwicklern Ihre  *
 * Verbesserungsvorschlge oder Fehler (und ggf. deren Berichtigung) mit.      *
 *                                                                             *
 * Fr den Unterricht sollten Sie nur die mSuchbaum.dcu Datei verwenden.       *
 * Diese muss sich im Ordner ..delphi/lib befinden. Die Angabe                 *
 * "uses mSuchbaum" ist dann schon ausreichend.                                *
 *                                                                             *
 * Danke fr Ihre Mitarbeit.                                                   *
 *******************************************************************************}

unit mSuchbaum;
interface
uses
  mBinaerbaum,mListe, mOrdnungsklasse;
type
 Suchbaum = class (Binaerbaum)
               hatListe:Liste;
               constructor init;
               function wurzelInhaltSuchbaum:Ordnungsklasse;
               function linkerSuchbaum:Suchbaum;
               function rechterSuchbaum:Suchbaum;
               procedure fuegeEin(pInhalt:Ordnungsklasse);
               function suche(pObjekt:Ordnungsklasse):Ordnungsklasse;
               procedure entferne(pObjekt:Ordnungsklasse);
               function sortierteListe:Liste;
               destructor gibFrei;override;
               protected
               procedure ergaenzeListe(pListe:Liste);
              end;

implementation


  constructor Suchbaum.init;
  begin
    inherited init;
  end;

  function Suchbaum.wurzelInhaltSuchbaum:Ordnungsklasse;
  begin
    result:=Ordnungsklasse(self.wurzelInhalt);
  end;

  function Suchbaum.linkerSuchbaum:Suchbaum;
  begin
    result:=Suchbaum(linkerTeilbaum);
  end;

  function Suchbaum.rechterSuchbaum:Suchbaum;
  begin
    result:=Suchbaum(rechterTeilbaum);
  end;


  procedure Suchbaum.fuegeEin(pInhalt:Ordnungsklasse);
  var
    lWurzelInhalt:Ordnungsklasse;
  begin
    if self.istLeer then
      self.ueberschreibeWurzel(pInhalt)
    else begin
      lWurzelInhalt:=self.wurzelInhaltSuchbaum;
      if pInhalt.istKleiner(lWurzelInhalt) then
         self.linkerSuchbaum.fuegeEin(pInhalt)
      else
        if pInhalt.istGroesser(lWurzelInhalt) then
          self.rechterSuchbaum.fuegeEin(pInhalt)
    end;
  end;

  function Suchbaum.suche(pObjekt:Ordnungsklasse):Ordnungsklasse;
  var
    lWurzelInhalt:Ordnungsklasse;
  begin
    if self.istLeer then
      result:=nil
    else begin
      lWurzelInhalt:=self.wurzelInhaltSuchbaum;
      if pObjekt.istKleiner(lWurzelInhalt) then
         result:=self.linkerSuchbaum.suche(pObjekt)
      else
        if pObjekt.istGroesser(lWurzelInhalt) then
             result:=self.rechterSuchbaum.suche(pObjekt)
           else
             result:=lWurzelInhalt
    end;
  end;


 procedure Suchbaum.entferne(pObjekt:Ordnungsklasse);
  var
    lWurzelInhalt:Ordnungsklasse;
    lKnoten, lGroessterLinkerKnoten, lVaterGroesster:Suchbaum;
  begin
    if not self.istLeer then begin
       lWurzelInhalt:=self.wurzelInhaltSuchbaum;
       if lWurzelInhalt.istGleich(pObjekt) then begin
          lWurzelInhalt.gibFrei;
          if self.rechterSuchbaum.istLeer and self.linkerSuchbaum.istLeer then begin
            self.rechterTeilbaum.gibFrei;
            self.haengeRechtsAn(nil);
            self.linkerTeilbaum.gibFrei;
            self.haengeLinksAn(nil);
            self.ueberschreibeWurzel(nil);
          end else
              if self.rechterTeilbaum.istLeer then begin
                lKnoten:=self.linkerSuchbaum;
                self.rechterTeilbaum.gibfrei;
                self.ueberschreibeWurzel(lKnoten.wurzelInhalt);
                self.haengeLinksAn(lKnoten.linkerTeilbaum);
                self.haengeRechtsAn(lKnoten.rechterTeilbaum);
                lKnoten.gibFrei;
              end else
                    if self.linkerTeilbaum.istLeer then begin
                       lKnoten:=self.rechterSuchbaum;
                       self.linkerTeilbaum.gibfrei;
                       self.ueberschreibeWurzel(lKnoten.wurzelInhaltSuchbaum);
                       self.haengeLinksAn(lKnoten.linkerTeilbaum);
                       self.haengeRechtsAn(lKnoten.rechterTeilbaum);
                       lKnoten.gibFrei;
                     end else begin
                           lVaterGroesster:=nil;
                           lGroessterLinkerKnoten:=self.linkerSuchbaum;
                           while not lGroessterLinkerKnoten.rechterSuchbaum.istLeer do begin
                             lVaterGroesster:=lGroessterLinkerKnoten;
                             lGroessterLinkerKnoten:=lGroessterLinkerKnoten.rechterSuchbaum;
                           end;
                           if not lVaterGroesster.istLeer then begin
                             lVaterGroesster.haengeRechtsAn(lGroessterLinkerKnoten.linkerSuchbaum);
                             lGroessterLinkerKnoten.haengeLinksAn(self.linkerTeilbaum)
                           end;
                           self.ueberschreibeWurzel(lGroessterLinkerKnoten.wurzelInhaltSuchbaum);
                           self.haengeLinksAn(lGroessterLinkerKnoten.linkerSuchbaum);
                           lGroessterLinkerKnoten.gibFrei;
                        end;
        end else
              if lWurzelInhalt.istKleiner(pObjekt) then begin
                 self.rechterSuchbaum.entferne(pObjekt);
               end else
                     self.linkerSuchbaum.entferne(pObjekt);
    end;
  end;

 function Suchbaum.sortierteListe:Liste;
  begin
   hatListe:=Liste.init;
   self.ergaenzeListe(hatListe);
   result:=hatListe;
 end;


  procedure Suchbaum.ergaenzeListe(pListe:Liste);
  begin
    if not self.istLeer then begin
       self.linkerSuchbaum.ergaenzeListe(pListe);
       pListe.haengeAn(self.wurzelInhaltSuchbaum);
       self.rechterSuchbaum.ergaenzeListe(pListe);
    end;
  end;

  destructor Suchbaum.gibFrei;
  begin
    inherited gibFrei;
  end;

end.
