{*******************************************************************************
 *                           Zeilenbereich Version 1.1.2                       *
 *                (c) 2002 Ulrich Borghoff    Gymnasium Wilnsdorf              *
 *                           eMail: sum-delphi@web.de                          *
 * *****************************************************************************
 * Diese Komponenten Version drfte unter Delphi ab Version ab 4 laufen        *
 *******************************************************************************
 * Bitte ndern Sie diese Datei nicht ab, sondern teilen den Entwicklern Ihre  *
 * Verbesserungsvorschlge oder Fehler (und ggf. deren Berichtigung) mit.      *
 *                                                                             *
 * Danke fr Ihre Mitarbeit.                                                   *
 *******************************************************************************}

unit mZeilenbereich;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, mSuM;

const NEUERABSATZ=#13#10;
      ZEILENUMBRUCH=#13#10;

type
  TZeilenbereich = class(TCustomListBox)

 private
    FFokusErhalten, FFokusVerloren, FTextGeaendert,FMarkierungGeaendert : tNotifyEvent;

    zWarSelektiert:array of Boolean;
    procedure aktualisiereSelektierung;
    function selektierungGeaendert:boolean;
    procedure setzeZustand(pAktiv:Wahrheitswert);
    procedure setzeSichtbarkeit(pSichtbar:Wahrheitswert);
    procedure setzeText(pInhalt:Zeichenkette);

  protected
    procedure doEnter; override;
    procedure doExit; override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  //  procedure change; override;
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;

  public

    constructor Create(AOwner: TComponent); override;
    constructor init(pLinks,pOben, pBreite, pHoehe: Zahl);  overload;
    constructor init(pLinks,pOben, pBreite, pHoehe: Zahl; pInhalt:Zeichenkette);  overload;

    procedure setzePosition(pLinks, pOben : Zahl); virtual;
    procedure setzeGroesse(pBreite, pHoehe : Zahl); virtual;

    function links:Zahl;  virtual;
    function oben:Zahl; virtual;
    function breite:Zahl;  virtual;
    function hoehe:Zahl; virtual;

    procedure verstecke; virtual;
    procedure zeige; virtual;
    function IstSichtbar:Wahrheitswert; virtual;

    procedure aktiviere; virtual;
    procedure deaktiviere; virtual;
    function istAktiviert: Wahrheitswert; virtual;

    procedure setzeFokus; virtual;
    function besitztFokus: Wahrheitswert; virtual;

    procedure setzeInhalt(pInhalt:Zeichenkette); overload; virtual;
    procedure setzeInhalt(pInhalt:Zahl); overload; virtual;

    function InhaltIstZeichenkette:Wahrheitswert; virtual;
    function InhaltIstZahl:Wahrheitswert; virtual;
    function InhaltIstGanzeZahl:Wahrheitswert; virtual;

    function inhaltAlsText:Zeichenkette; virtual;

    function inhaltAlsZahl:Zahl; virtual;
    function inhaltAlsGanzeZahl:GanzeZahl; virtual;

    procedure setzeSchriftart(pArt:Zeichenkette);
    procedure setzeSchriftGroesse(pGroesse:GanzeZahl);
    procedure setzeSchriftFarbe(pFarbe:GanzeZahl);
    procedure setzeSchriftStil(pStil:GanzeZahl);

    function istMarkiert : Wahrheitswert;

    function anzahl : GanzeZahl;

    function markierungsAnfang:GanzeZahl;
    function markierungsEnde:GanzeZahl;
    function markierterInhalt:Zeichenkette;
    procedure setzeMarkierung(pAnfang, pEnde : GanzeZahl);
    procedure markiereAlles;
    procedure markiereNichts;

    procedure loescheMarkierung;
    procedure loesche(pAnfang, pEnde :GanzeZahl);
    procedure loescheAlles;

    function teilInhalt(pAnfang, pEnde : GanzeZahl):Zeichenkette;

    procedure fuegeEin(pText:Zeichenkette; pStelle:GanzeZahl); overload;
    procedure fuegeEin(pZahl:Zahl; pStelle:GanzeZahl); overload;
    procedure haengeAn(pText:Zeichenkette); overload;
    procedure haengeAn(pZahl:Zahl); overload;

    procedure gibFrei; virtual;

    published

    property _Inhalt: Zeichenkette read inhaltAlsText write setzeText;
    property _IstAktiviert : Wahrheitswert read istAktiviert write SetzeZustand;
    property _IstSichtbar : Wahrheitswert read IstSichtbar write SetzeSichtbarkeit;
    property font;
    property FokusErhalten : tNotifyEvent read FFokusErhalten write FFokusErhalten;
    property FokusVerloren : tNotifyEvent read FFokusVerloren write FFokusVerloren;
    property TextGeaendert : tNotifyEvent read FTextGeaendert write FTextGeaendert;
    property MarkierungGeaendert : tNotifyEvent read FMarkierungGeaendert write FMarkierungGeaendert;

  end;

procedure Register;

implementation

constructor TZeilenbereich.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.parent:=screen.activeForm;
  self.MultiSelect:=true;
 // self.aktualisiereSelektierung;
end;

constructor TZeilenbereich.init(pLinks,pOben, pBreite, pHoehe: Zahl);
begin
  inherited create(screen.activeForm);
  self.parent:=screen.activeForm;
  self.MultiSelect:=true;
  //self.aktualisiereSelektierung;
  ControlStyle := [csSetCaption, csOpaque, csDoubleClicks];
  TabStop := True;
  self.setzePosition(pLinks,pOben);
  self.setzeGroesse(pBreite,pHoehe);
end;

constructor TZeilenbereich.init(pLinks,pOben, pBreite, pHoehe: Zahl; pInhalt:Zeichenkette);
begin
  self.init(pLinks,pOben, pBreite, pHoehe);
  self.parent:=screen.activeForm;
  self.MultiSelect:=true;
 // self.aktualisiereSelektierung;
  self.setzeInhalt(pInhalt);
end;

procedure TZeilenbereich.setzePosition(pLinks, pOben:Zahl);
begin
 self.left:=round(pLinks);
 self.Top:=round(pOben);
end;

procedure TZeilenbereich.setzeGroesse(pBreite, pHoehe:Zahl);
begin
 self.Width:=round(pBreite);
 self.Height:=round(pHoehe);
end;

function TZeilenbereich.links:Zahl;
begin
 result:=self.left;
end;

function TZeilenbereich.oben:Zahl;
begin
  result:=self.top;
end;

function TZeilenbereich.breite:Zahl;
begin
  result:=self.width;
end;

function TZeilenbereich.hoehe:Zahl;
begin
  result:=self.height;
end;

procedure TZeilenbereich.verstecke;
begin
 self.visible:=false;
end;

procedure TZeilenbereich.zeige;
begin
 self.visible:=true;
end;

function TZeilenbereich.IstSichtbar:Wahrheitswert;
begin
  result:=self.visible;
end;

procedure TZeilenbereich.aktiviere;
begin
 self.enabled:=true;
end;

procedure TZeilenbereich.deaktiviere;
begin
 self.enabled:=false;
end;

function TZeilenbereich.istAktiviert: Wahrheitswert;
begin
 result:=self.enabled;
end;

procedure TZeilenbereich.setzeFokus;
begin
 screen.ActiveForm.FocusControl(self);
 self.setfocus;
 self.ShowControl(self);
end;

function TZeilenbereich.besitztFokus: Wahrheitswert;
begin
 result:=self.focused;
end;

procedure TZeilenbereich.setzeText(pInhalt:Zeichenkette);
 var lStelle, lAnfang :integer;
begin
  if pInhalt<>'' then
  begin
    self.loescheAlles;
    lAnfang:=1;
    for lStelle:=1 to length(pInhalt) do
    if copy(pInhalt,lStelle,2)=NEUERABSATZ then
    begin
      self.Items.Add(copy(pInhalt,lAnfang, lStelle-lAnfang));
      lAnfang:=lStelle+2;
    end;
      self.Items.Add(copy(pInhalt,lAnfang, length(pInhalt)-lAnfang+1));
  end;
  self.aktualisiereSelektierung;
end;

procedure TZeilenbereich.setzeInhalt(pInhalt:Zeichenkette);
begin
 self.setzeText(pInhalt);
 self.update;
end;

procedure TZeilenbereich.setzeInhalt(pInhalt:Zahl);
begin
  self.setzeInhalt(floatToStr(pInhalt));
end;

function TZeilenbereich.InhaltIstZeichenkette:Wahrheitswert;
begin
  result:=true;
end;

function TZeilenbereich.InhaltIstZahl:Wahrheitswert;
  var lWert: Zahl;
      lcode : integer;
begin
  val(self.inhaltAlsText,lWert,lCode);
  result:=(lcode=0);
end;

function TZeilenbereich.InhaltIstGanzeZahl:Wahrheitswert;
  var lWert: GanzeZahl;
      code : integer;
begin
  val(self.inhaltAlsText,lWert,Code);
  result:=(code=0);
end;

function TZeilenbereich.InhaltAlsText:Zeichenkette;
  var lZeile:integer;
begin
  result:='';
  for lZeile:=0 to self.Items.Count-1 do
    result := result + self.Items.strings[lZeile] + NEUERABSATZ;
end;

function TZeilenbereich.inhaltAlsZahl:Zahl;
begin
  if self.InhaltistZahl then result:=strTofloat(self.inhaltAlsText)
  else
  begin
    MessageDlg('Eingabe keine Zahl.',mtError,[mbOK],0);
    result:=0;
  end;
end;

function TZeilenbereich.inhaltAlsGanzeZahl:GanzeZahl;
begin
  if self.InhaltIstGanzeZahl then result:=strToInt(self.inhaltAlsText)
  else
  begin
    MessageDlg('Eingabe keine ganze Zahl.',mtError,[mbOK],0);
    result:=0;
  end;
end;

procedure TZeilenbereich.setzeSchriftart(pArt:Zeichenkette);
begin
  self.Font.Name:=pArt;
end;

procedure TZeilenbereich.setzeSchriftGroesse(pGroesse:GanzeZahl);
begin
  self.Font.size:=pGroesse;
end;

procedure TZeilenbereich.setzeSchriftFarbe(pFarbe:GanzeZahl);
begin
  self.Font.Color:=SuMfarbumrechnung(pFarbe); {farbumrechnung aus mSuM}
end;

procedure TZeilenbereich.setzeSchriftStil(pStil:GanzeZahl);
begin
  self.Font.Style:=SuMstilumrechnung(pStil);  {stilumrechnung aus mSuM}
end;

procedure TZeilenbereich.gibFrei;
begin
 self.destroy;
end;

function TZeilenbereich.istMarkiert : Wahrheitswert;
  var lZeile:integer;
begin
  result:=false;
  lZeile:=0;
  while (lZeile <= self.Items.Count-1) and not result do
  begin
    if self.Selected[lZeile] then result:=true;;
    inc(lZeile);
  end;
end;

function TZeilenbereich.anzahl : GanzeZahl;
begin
  result:=self.Items.Count;
end;

function TZeilenbereich.markierungsAnfang:GanzeZahl;
  var lZeile:integer;
begin
  result:=0;
  lZeile:=0;
  while (lZeile <= self.Items.Count-1) and (result=0) do
  begin
    if self.Selected[lZeile] then result:=lZeile+1;
    inc(lZeile);
  end;
end;

function TZeilenbereich.markierungsEnde:GanzeZahl;
  var lZeile:integer;
begin
  result:=0;
  lZeile:=self.Items.Count-1;
  while (lZeile >=0 ) and (result=0) do
  begin
    if self.Selected[lZeile] then result:=lZeile+1;
    dec(lZeile);
  end;
end;

function TZeilenbereich.markierterInhalt:Zeichenkette;
  var lZeile:integer;
begin
  result:='';
  if self.istmarkiert then
    for lZeile:=self.markierungsAnfang-1 to self.markierungsEnde-1 do
      result := result + self.Items.strings[lZeile] + NEUERABSATZ;
end;

procedure TZeilenbereich.setzeMarkierung(pAnfang, pEnde : GanzeZahl);
  var lZeile:integer;
begin
  if (pAnfang<=pEnde) and (pEnde<= self.items.count) then
    for lZeile:=pAnfang-1 to pEnde-1 do
      self.Selected[lZeile]:=true;
  self.aktualisiereSelektierung;
end;

procedure TZeilenbereich.markiereAlles;
 var lZeile:integer;
begin
  for lZeile:=0 to self.Items.Count-1 do
    self.Selected[lZeile]:=true;
  self.aktualisiereSelektierung;
end;

procedure TZeilenbereich.markiereNichts;
 var lZeile:integer;
begin
  for lZeile:=0 to self.Items.Count-1 do
    self.Selected[lZeile]:=false;
  self.aktualisiereSelektierung;
end;

procedure TZeilenbereich.loescheMarkierung;
 var lZeile:integer;
begin
  lZeile:=0;
  while lZeile<=self.Items.Count-1 do
  begin
    if self.Selected[lZeile] then self.items.Delete(lZeile)
    else inc(lZeile);
  end;
  self.aktualisiereSelektierung;
end;

procedure TZeilenbereich.loesche(pAnfang, pEnde :GanzeZahl);
 var lZeile:integer;
begin
  for lZeile:=pAnfang-1 to pEnde-1 do
    self.items.Delete(pAnfang-1);
  self.aktualisiereSelektierung;
end;

procedure TZeilenbereich.loescheAlles;
begin
  self.Clear;
end;

function TZeilenbereich.teilInhalt(pAnfang, pEnde : GanzeZahl):Zeichenkette;
  var lZeile:integer;
begin
  result:='';
  if (pAnfang<=pEnde) and (pEnde<= self.items.count) then
    for lZeile:=pAnfang-1 to pEnde-1 do
      result := result + self.Items.strings[lZeile] + NEUERABSATZ;
end;

procedure TZeilenbereich.fuegeEin(pText:Zeichenkette; pStelle:GanzeZahl);
  var lAnfang, lPosition:GanzeZahl;
begin
  if pStelle <= self.Items.Count then
  begin
    lAnfang:=1;
    for lPosition:=1 to length(pText) do
      if copy(pText,lPosition,2)=NEUERABSATZ then
      begin
        self.Items.Insert(pStelle-1, copy(pText,lAnfang, lPosition-lAnfang));
        lAnfang:=lPosition+2;
        inc(pStelle);
      end;
    self.Items.Insert(pStelle-1, copy(pText,lAnfang, length(pText)-lAnfang+1));
  end
  else self.haengeAn(pText);
  self.aktualisiereSelektierung;
end;

procedure TZeilenbereich.fuegeEin(pZahl:Zahl; pStelle:GanzeZahl);
begin
  self.fuegeEin(floatToStr(pZahl), pStelle);
end;

procedure TZeilenbereich.haengeAn(pText:Zeichenkette);
  var lAnfang, lPosition:GanzeZahl;
begin
  lAnfang:=1;
  for lPosition:=1 to length(pText) do
    if copy(pText,lPosition,2)=NEUERABSATZ then
    begin
      self.Items.Add(copy(pText,lAnfang, lPosition-lAnfang));
      lAnfang:=lPosition+2;
    end;
  self.Items.Add(copy(pText,lAnfang, length(pText)-lAnfang+1));
  self.aktualisiereSelektierung;
end;

procedure TZeilenbereich.haengeAn(pZahl:Zahl);
begin
  self.Items.Add(floatTostr(pZahl));
end;


// private

procedure TZeilenbereich.aktualisiereSelektierung;
  var lZeile:GanzeZahl;
begin
 if length(zWarSelektiert)<>self.Items.Count then setlength(zWarSelektiert, self.Items.Count);
 for lZeile:=0 to self.Items.Count-1 do
   zWarSelektiert[lZeile]:=self.Selected[lZeile];
end;

function TZeilenbereich.selektierungGeaendert:boolean;
  var lZeile:GanzeZahl;
begin
  result:=false;
  for lZeile:=0 to self.Items.Count-1 do
   if not(zWarSelektiert[lZeile]=self.Selected[lZeile]) then result:=true;
  if result then self.aktualisiereSelektierung;
end;

procedure TZeilenbereich.setzeZustand(pAktiv:Wahrheitswert);
begin
 self.enabled:=pAktiv;
end;

procedure TZeilenbereich.SetzeSichtbarkeit(pSichtbar:Wahrheitswert);
begin
 self.visible:=pSichtbar;
end;

// Ereignisse

procedure TZeilenbereich.doEnter;
begin
  if assigned(FokusErhalten) then FokusErhalten(self);
  inherited doEnter;
end;

procedure TZeilenbereich.doExit;
begin
  if assigned(FokusVerloren) then FokusVerloren(self);
  inherited doExit;
end;

procedure TZeilenbereich.MouseUp(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if assigned(MarkierungGeaendert) and self.selektierungGeaendert then MarkierungGeaendert(self);
  inherited;
end;

{procedure TZeilenbereich.change;
begin
  if assigned(TextGeaendert) then TextGeaendert(self);
  inherited change;
end;  }

procedure TZeilenbereich.KeyUp(var Key: Word; Shift: TShiftState);
begin
  inherited;
  if assigned(MarkierungGeaendert) and self.selektierungGeaendert then MarkierungGeaendert(self);
end;

// Registrierung

procedure Register;
begin
  RegisterComponents('Schule', [TZeilenbereich]);
end;


end.
